# **Supported/unsupported devices**

### Table of contents

*   [Supported/unsupported devices](#Supported_unsupported devices)
    *   [Supported target devices](#Supported_target_devices)
    *   [Unsupported target devices](#Unsupported_target_devices)

# Supported/unsupported devices

## Supported target devices

**Allied Telesis**

| Device   | Notes                   |
| -------- | ----------------------- |
| AT-8000S | AT-S94 Version 3.0.0.35 |

**BlueCoat**

| Device      | Notes                                    |
| ----------- | ---------------------------------------- |
| Version 5.x |                                          |
| Version 6.x | seems to have an IP-address/Interface mapping issue ? |

**Brocade**

| Device               | Notes                                    |
| -------------------- | ---------------------------------------- |
| Fiber Channel Switch | tested with FabricOS v6.1.1a, 6.2.2.e, 6.4.1.a |

**Cisco**

| Device         | Notes    |
| -------------- | -------- |
| Catalyst 4000  | IOS 12.2 |
| Catalyst 4500  | IOS 12.2 |
| Catalyst 6506  | IOS 12.2 |
| C2800          | IOS 12.4 |
| C3825          | IOS 12.4 |
| C3845          | IOS 12.4 |
| Cisco ASR 1002 | IOS 12.2 |
| C1812          | IOS 12.4 |
| C3560          | IOS 12.2 |
| C2950          | IOS 12.1 |
| C2960S         | IOS 12.2 |
| Catalyst 6509  | IOS 12.2 |
| C3560          | IOS 12.2 |
| C2970          | IOS 12.2 |
| C2950          | IOS 12.1 |
| C2900XL        | IOS 12.0 |
| C2940          | IOS 12.1 |

**Citrix**

| Device    | Notes  |
| --------- | ------ |
| NetScaler | NS10.1 |

**Dell**

| Device  | Notes        |
| ------- | ------------ |
| Force10 | (10Gb) - 1.0 |
| Data Domain | 5.6.1.0-513706 |
| Data Domain | 6.0.2.20-587212 |

**HP**

| Device                                   | Notes                              |
| ---------------------------------------- | ---------------------------------- |
| ProLiant ML570 G3                        |                                    |
| ProLiant DL580 G7                        |                                    |
| ProCurve Switch 5406                     |                                    |
| ProCurve Switch 2910                     |                                    |
| ProCurve Switch 6410                     |                                    |
| ProCurve Switch 2900-48G (J9050A)        | revision T.13.71                   |
| ProCurve Switch 5412zl Intelligent Edge (J8698A) | revision K.15.08.0013, ROM K.15.28 |

**Juniper**

| Device             | Notes               |
| ------------------ | ------------------- |
| Netscreen SSG-350M | firmware 6.3.0r10.0 |
| Netscreen SSG-550  | firmware 6.3.0r9.0  |
| Netscreen SSG-5    |                     |
| Netscreen 5400     |                     |
| NetScreen ISG-2000 |                     |
| SRX-240            | JunOS ver 10.x/9.x  |
| M10i               | JunOS ver 10.x/9.x  |
| MX80               | JunOS ver 10.x/9.x  |
| SRX-650            | JunOS ver 10.x/9.x  |
| M120               | JunOS ver 10.x/9.x  |
| J2320              | JunOS 9.0R1.10      |

**Netapp**

| Device        | Notes                                |
| ------------- | ------------------------------------ |
| FAS 3140      | tested with NetApp release 7.3.5.1P2 |
| FAS 3240      | tested with NetApp release 7.3.5.1P2 |
| NearStore VTL |                                      |

**SUN-Oracle**

| Device                 | Notes                                    |
| ---------------------- | ---------------------------------------- |
| SPARC Sunfire V890     | tested on solaris 10 u8/u9/u10 and ce interfaces |
| SPARC Enterprise M5000 | tested on solaris 10 u8/u9/u10 and bge, sppp interfaces |
| SPARC Enterprise T5120 | tested on solaris 10 u8/u9/u10 and e1000g interfaces |
| SPARC Enterprise T3-1  | tested on solaris 10 u8/u9/u10 and igb interfaces |

**Linux-Unix**

| Device                                   | Notes |
| ---------------------------------------- | ----- |
| RedHat flavors |       |
| Debian flavors |       |
| Solaris        |       |
| HPUX 11.31     |       |

**Vmware guests**

| Device                                   | Notes |
| ---------------------------------------- | ----- |
| On esx 3.5 (Windows Server 2000/2003/2008, CentOS, Debian) |       |
| On esx 4 (Windows Server 2000/2003/2008, CentOS, Debian) |       |

Unsupported target devices


The plugin has been recognized as not working with the following devices:

**Cisco**

| Device | Notes |
| ------ | ----- |
| xxx    | xxx   |
| xxx    | xxx   |

_TO UPDATE WHEN DATA AVAILABLE_

## Unsupported target devices

_TO UPDATE WHEN DATA AVAILABLE_
